%bcond_with dotests

%global __tar /opt/freeware/bin/tar

%global py_major 3.9

%global python_major python%{py_major}

%global pkgname matplotlib 

%global meta_package python3-%{pkgname}

%global python3_sitearch %(%{python_major} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")

Name:           %{python_major}-%{pkgname}
Version:        3.9.4
Release:        1 
Summary:        A tool for plotting graphs
License:        Python Software Foundation License (PSF)
URL:            https://pypi.python.org/pypi/%{pkgname}
Source0:        https://files.pythonhosted.org/packages/source/p/%{pkgname}/%{pkgname}-%{version}.tar.gz
Patch0:         matplotlib-3.9.4-Disable-lto.patch

BuildRequires:  %{python_major}-devel >= %{py_major}
BuildRequires:  %{python_major}-setuptools >= 65.2.0
BuildRequires:  openblas-devel >= 0.3.18
BuildRequires:  libjpeg-devel >= 9e
BuildRequires:  %{python_major}-wheel >= 0.41.2
BuildRequires:  %{python_major}-setuptools-scm >= 8.0.4
BuildRequires:  %{python_major}-certifi >= 2020.06.20
BuildRequires:  %{python_major}-oldest-supported-numpy >= 2023.10.25
BuildRequires:  %{python_major}-typing_extensions >= 4.8.0
BuildRequires:  %{python_major}-pybind11 >= 2.13
BuildRequires:  %{python_major}-numpy >= 2.0.2
BuildRequires:  %{python_major}-packaging >= 20
BuildRequires:  %{python_major}-tomli >= 1
BuildRequires:  meson >= 1.6.1
Requires:       %{python_major}-packaging >= 20
Requires:       %{python_major} >= %{py_major}.16
Requires:       %{python_major}-pyparsing >= 2.4.4
Requires:       %{python_major}-kiwisolver >= 1.4.5
Requires:       %{python_major}-dateutil >= 2.7.17
Requires:       %{python_major}-numpy >= 2.0.2 
Requires:       %{python_major}-pillow >= 10.3.0
Requires:       %{python_major}-cycler >= 0.11
Requires:       %{python_major}-importlib_resources >= 6.0.1
Requires:       openblas >= 0.3.18
Requires:       libjpeg >= 9e
Requires:       %{python_major}-contourpy >= 1.1.1-3
Requires:       %{python_major}-fonttools >= 4.42.1

%description
Matplotlib is a comprehensive library for creating static, animated, and interactive visualizations in Python.

%package -n %{meta_package}
Summary:       Meta-package for %{name}

Requires:      python3 >= %{py_major}.16
Requires:      %{name} = %{version}-%{release}
Requires:      python3-packaging >= 20
Requires:      python3-pyparsing >= 2.4.4
Requires:      python3-kiwisolver >= 1.4.5
Requires:      python3-dateutil >= 2.7.17
Requires:      python3-numpy >= 2.0.2 
Requires:      python3-pillow >= 10.3.0
Requires:      python3-cycler >= 0.11
Requires:      python3-importlib_resources >= 6.0.1
Requires:      python3-contourpy >= 1.1.1-3
Requires:      python3-fonttools >= 4.42.1

%description -n %{meta_package}
This is a Meta-package for %{name} package.


%prep
%autosetup -n %{pkgname}-%{version}


%build

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

# These options are for Meson and not pip. --no-build-isolation can be removed after meson >= 1.7.0
export CXX="g++ -pthread"
export CXXFLAGS=-maix64
export OBJECT_MODE=64
export LDFLAGS=-maix64
export CC="gcc -pthread"
export CFLAGS=-maix64
export LDFLAGS=-Wl,-blibpath:/opt/freeware/lib/pthread:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib

%{python_major} -m pip install . --root %{buildroot} --no-build-isolation -I --no-deps -v

# Unfortunately pip uses ninja install instead of meson install and we cannot write our install_rpath.
# Hence manually change this. Mind it that if the build_rpath in future changes then take care of what is going in sed.
# Both the paths must be equal in length.
# If we move to openXL in future we will not have to do this. Or if meson install will be used by pip.

cd %{buildroot}

find . -name "*.so" -type f | while read -r file; do dump -Hov -X64 $file; done

find . -name "*.so" -type f | while read -r file; do
sed -i 's#/opt/freeware/lib/gcc/powerpc-ibm-aix7.1.0.0/10/pthread:/opt/freeware/lib/pthread:/opt/freeware/lib/gcc/powerpc-ibm-aix7.1.0.0/10:/opt/freeware/lib:/lib:/usr/lib#/opt/freeware/lib/pthread:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::#' $file

dump -Hov -X64 $file;
done

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%license LICENSE
%doc README.md
%{python3_sitearch}/*

%files -n %{meta_package}
%defattr(-,root,system,-)

%changelog
* Tue Jan 07 2024 Aditya Kamath <Aditya.Kamath1@ibm.com> - 3.9.4-1
- Update to last supported version for python3.9.

* Tue Aug 27 2024 Sumitra Dawn <Sumitra.Dawn@ibm.com> - 3.7.2-3
- Rebuild with updated pillow library name

* Fri May 24 2024 Aditya Kamath <Aditya.Kamath1@ibm.com> - 3.7.2-2
- Rebuild with LDFLAGS

* Fri Sep 15 2023 Aditya Kamath <Aditya.Kamath1@ibm.com> - 3.7.2-1
- matplotlib for python3.9
